Package org.zkoss.stateless.sul

## Interface ILabelImageElement<I extends ILabelImageElement>

- All Superinterfaces:
    `IChildrenOfInputgroup<I>`, `IComponent<I>`, `IHtmlBasedComponent<I>`, `ILabelElement<I>`, `IXulElement<I>`
  All Known Subinterfaces:
    `IA<I>`, `IAuxheader<I>`, `IButton`, `IButtonBase<I>`, `ICaption<I>`, `ICheckbox`, `ICheckboxBase<I>`, `IColumn<I>`, `ICombobutton`, `IComboitem`, `IFileupload`, `IFisheye`, `IFooter<I>`, `IFooterElement<I>`, `IHeaderElement<I>`, `IListcell<I>`, `IListfooter<I>`, `IListheader<I>`, `IMenu`, `IMenuitem`, `INav`, `INavitem`, `IOrgnode<I>`, `IRadio`, `ITab`, `IToolbarbutton`, `ITreecell<I>`, `ITreecol<I>`, `ITreefooter<I>`

      public interface ILabelImageElement<I extends ILabelImageElement>
      extends ILabelElement<I>, IChildrenOfInputgroup<I>

  Immutable `LabelImageElement` interface

  To turn on the preload image facility for this component, you have to specify `withPreloadImage(boolean)` to true.

  Or configure it from zk.xml by setting library properties. For example,

        <library-property/>
           <name>org.zkoss.zul.image.preload</name/>
           <value>true</value/>
       </library-property/>

  Note: with zk.xml setting, it will affect to all subcomponents, which are extended from `ILabelImageElement`
  Author:
    katherine

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getHoverImage()` | Returns the URI of the hover image.
    `default java.lang.String` | `getIconSclass()` | Returns the icon font CSS class name.
    `default java.lang.String[]` | `getIconSclasses()` | Returns the icon font CSS class name String array.
    `default java.lang.String` | `getIconTooltip()` | Returns the iconTooltip font.
    `default java.lang.String[]` | `getIconTooltips()` | Returns the iconTooltip font String array.
    `default java.lang.String` | `getImage()` | Returns the image URI.
    `default boolean` | `isPreloadImage()` | Returns whether to preload the image.
    `I` | `withHoverImage​(java.lang.String hoverImage)` | Returns a copy of `this` immutable component with the specified `hoverImage` URI.
    `I` | `withIconSclass​(java.lang.String iconSclass)` | Returns a copy of `this` immutable component with the specified `iconSclass`.
    `I` | `withIconSclasses​(java.lang.String[] iconSclasses)` | Returns a copy of `this` immutable component with the specified `iconSclasses` String array.
    `I` | `withIconTooltip​(java.lang.String iconTooltip)` | Returns a copy of `this` immutable component with the specified `iconTooltip`.
    `I` | `withIconTooltips​(java.lang.String[] iconTooltips)` | Returns a copy of `this` immutable component with the specified `iconTooltips` String array.
    `I` | `withImage​(java.lang.String image)` | Returns a copy of `this` immutable component with the specified `image` URI.
    `I` | `withPreloadImage​(boolean preloadImage)` | Returns a copy of `this` immutable component with the specified `preloadImage` URI.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetClass, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Method Detail

    - #### getIconSclass

          @Nullable
          default java.lang.String getIconSclass()

      Returns the icon font CSS class name.

    - #### withIconSclass

          I withIconSclass​(@Nullable
                           java.lang.String iconSclass)

      Returns a copy of `this` immutable component with the specified `iconSclass`.

      Sets the CSS class name for the icon font.

      Parameters:
        `iconSclass` - A CSS class name for the icon font.
      Returns:
        A modified copy of the `this` object

    - #### getIconSclasses

          @Nullable
          default java.lang.String[] getIconSclasses()

      Returns the icon font CSS class name String array.

    - #### withIconSclasses

          I withIconSclasses​(@Nullable
                             java.lang.String[] iconSclasses)

      Returns a copy of `this` immutable component with the specified `iconSclasses` String array.

      Sets the CSS class name for the icon font.

      Parameters:
        `iconSclasses` - A CSS class name for the icon font.
      Returns:
        A modified copy of the `this` object

    - #### getIconTooltip

          @Nullable
          default java.lang.String getIconTooltip()

      Returns the iconTooltip font.

    - #### withIconTooltip

          I withIconTooltip​(@Nullable
                            java.lang.String iconTooltip)

      Returns a copy of `this` immutable component with the specified `iconTooltip`.

      Sets the iconTooltip.

      Parameters:
        `iconTooltip` - A content String for iconTooltip font.
      Returns:
        A modified copy of the `this` object

    - #### getIconTooltips

          @Nullable
          default java.lang.String[] getIconTooltips()

      Returns the iconTooltip font String array.

    - #### withIconTooltips

          I withIconTooltips​(@Nullable
                             java.lang.String[] iconTooltips)

      Returns a copy of `this` immutable component with the specified `iconTooltips` String array.

      Sets the iconTooltip.

      Parameters:
        `iconTooltips` - A content String array for iconTooltip font.
      Returns:
        A modified copy of the `this` object

    - #### getImage

          @Nullable
          default java.lang.String getImage()

      Returns the image URI.

      Default: `null`.

    - #### withImage

          I withImage​(@Nullable
                      java.lang.String image)

      Returns a copy of `this` immutable component with the specified `image` URI.

      Sets the image URI. The image would hide if specify to `null`

      Returns:
        A modified copy of the `this` object

    - #### getHoverImage

          @Nullable
          default java.lang.String getHoverImage()

      Returns the URI of the hover image. The hover image is used when the mouse is moving over this component.

      Default: `null`.

    - #### withHoverImage

          I withHoverImage​(@Nullable
                           java.lang.String hoverImage)

      Returns a copy of `this` immutable component with the specified `hoverImage` URI.

      Sets the image URI. The hover image is used when the mouse is moving over this component.

      Returns:
        A modified copy of the `this` object

    - #### isPreloadImage

          default boolean isPreloadImage()

      Returns whether to preload the image.

      Default: `false`, if the `"org.zkoss.zul.image.preload"` library property is not set in zk.xml.

    - #### withPreloadImage

          I withPreloadImage​(boolean preloadImage)

      Returns a copy of `this` immutable component with the specified `preloadImage` URI.

      Sets to `true` to enable to preload the image. Note: the priority of this attribute is higher than zk.xml if both preload image are specified.

      Returns:
        A modified copy of the `this` object